Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javax.security.auth.kerberos
Class KerberosTicket

    java.lang.Object
      javax.security.auth.kerberos.KerberosTicket

All Implemented Interfaces:
  java.io.Serializable, javax.security.auth.Destroyable, javax.security.auth.Refreshable

    public class KerberosTicket

extends java.lang.Object
implements javax.security.auth.Destroyable, javax.security.auth.Refreshable, java.io.Serializable

This class encapsulates a Kerberos ticket and associated information as viewed from the client's point of view. It captures all information that the Key Distribution Center (KDC) sends to the client in the reply message KDC-REP defined in the Kerberos Protocol Specification (RFC 1510).

All Kerberos JAAS login modules that authenticate a user to a KDC should use this class. Where available, the login module might even read this information from a ticket cache in the operating system instead of directly communicating with the KDC. During the commit phase of the JAAS authentication process, the JAAS login module should instantiate this class and store the instance in the private credential set of a `Subject`.

It might be necessary for the application to be granted a `PrivateCredentialPermission` if it needs to access a KerberosTicket instance from a Subject. This permission is not needed when the application depends on the default JGSS Kerberos mechanism to access the KerberosTicket. In that case, however, the application will need an appropriate `ServicePermission`.

Note that this class is applicable to both ticket granting tickets and other regular service tickets. A ticket granting ticket is just a special case of a more generalized service ticket.

Since:
  1.4
Version:
  1.12, 12/03/01
Author:
  Mayank Upadhyay
See Also:
  `Subject`, `PrivateCredentialPermission`, `LoginContext`, `GSSCredential`, `GSSManager`, Serialized Form

Constructor Summary
`KerberosTicket(byte[] asn1Encoding, KerberosPrincipal client, KerberosPrincipal server, byte[] sessionKey, int keyType, boolean[] flags, java.util.Date authTime, java.util.Date startTime, java.util.Date endTime, java.util.Date renewTill, java.net.InetAddress[] clientAddresses)` Constructs a KerberosTicket using credentials information that a client either receives from a KDC or reads from a cache.

Method Summary
`void` | `destroy()` Destroys the ticket and destroys any sensitive information stored in it.
`java.util.Date` | `getAuthTime()` Returns the time that the client was authenticated.
`KerberosPrincipal` | `getClient()` Returns the client principal associated with this ticket.
`java.net.InetAddress[]` | `getClientAddresses()` Returns a list of addresses from where the ticket can be used.
`byte[]` | `getEncoded()` Returns an ASN.1 encoding of the entire ticket.
`java.util.Date` | `getEndTime()` Returns the expiration time for this ticket's validity period.
`boolean[]` | `getFlags()` Returns the flags associated with this ticket.
`java.util.Date` | `getRenewTill()` Returns the latest expiration time for this ticket, including all renewals.
`KerberosPrincipal` | `getServer()` Returns the service principal associated with this ticket.
`javax.crypto.SecretKey` | `getSessionKey()` Returns the session key associated with this ticket.
`int` | `getSessionKeyType()` Returns the key type of the session key associated with this ticket as defined by the Kerberos Protocol Specification.
`java.util.Date` | `getStartTime()` Returns the start time for this ticket's validity period.
`boolean` | `isCurrent()` Determines if this ticket is still current.
`boolean` | `isDestroyed()` Determines if this ticket has been destroyed.
`boolean` | `isForwardable()` Determines if this ticket is forwardable.
`boolean` | `isForwarded()` Determines if this ticket had been forwarded or was issued based on authentication involving a forwarded ticket-granting ticket.
`boolean` | `isInitial()` Determines if this ticket was issued using the Kerberos AS-Exchange protocol, and not issued based on some ticket-granting ticket.
`boolean` | `isPostdated()` Determines is this ticket is post-dated.
`boolean` | `isProxiable()` Determines if this ticket is proxiable.
`boolean` | `isProxy()` Determines is this ticket is a proxy-ticket.
`boolean` | `isRenewable()` Determines is this ticket is renewable.
`void` | `refresh()` Extends the validity period of this ticket.
`java.lang.String` | `toString()` DOCUMENT ME!

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### KerberosTicket

    public KerberosTicket(byte[] asn1Encoding,
                          KerberosPrincipal client,
                          KerberosPrincipal server,
                          byte[] sessionKey,
                          int keyType,
                          boolean[] flags,
                          java.util.Date authTime,
                          java.util.Date startTime,
                          java.util.Date endTime,
                          java.util.Date renewTill,
                          java.net.InetAddress[] clientAddresses)

  Constructs a KerberosTicket using credentials information that a client either receives from a KDC or reads from a cache.

  Parameters:
    `asn1Encoding` - the ASN.1 encoding of the ticket as defined by the Kerberos protocol specification.
    `client` - the client that owns this service ticket
    `server` - the service that this ticket is for
    `sessionKey` - the raw bytes for the session key that must be used to encrypt the authenticator that will be sent to the server
    `keyType` - the key type for the session key as defined by the Kerberos protocol specification.
    `flags` - the ticket flags. Each element in this array indicates the value for the corresponding bit in the ASN.1 BitString that represents the ticket flags. If the number of elements in this array is less than the number of flags used by the Kerberos protocol, then the missing flags will be filled in with false.
    `authTime` - the time of initial authentication for the client
    `startTime` - the time after which the ticket will be valid. This may be null in which case the value of authTime is treated as the startTime.
    `endTime` - the time after which the ticket will no longer be valid
    `renewTill` - an absolute expiration time for the ticket, including all renewal that might be possible. This field may be null for tickets that are not renewable.
    `clientAddresses` - the addresses from where the ticket may be used by the client. This field may be null when the ticket is usable from any address.

Method Detail

### getClient

    public final KerberosPrincipal getClient()

  Returns the client principal associated with this ticket.

  Returns:
    the client principal.

### getServer

    public final KerberosPrincipal getServer()

  Returns the service principal associated with this ticket.

  Returns:
    the service principal.

### getSessionKey

    public final javax.crypto.SecretKey getSessionKey()

  Returns the session key associated with this ticket.

  Returns:
    the session key.

### getSessionKeyType

    public final int getSessionKeyType()

  Returns the key type of the session key associated with this ticket as defined by the Kerberos Protocol Specification.

  Returns:
    the key type of the session key associated with this ticket.
  See Also:
    `getSessionKey()`

### isForwardable

    public final boolean isForwardable()

  Determines if this ticket is forwardable.

  Returns:
    true if this ticket is forwardable, false if not.

### isForwarded

    public final boolean isForwarded()

  Determines if this ticket had been forwarded or was issued based on authentication involving a forwarded ticket-granting ticket.

  Returns:
    true if this ticket had been forwarded or was issued based on authentication involving a forwarded ticket-granting ticket, false otherwise.

### isProxiable

    public final boolean isProxiable()

  Determines if this ticket is proxiable.

  Returns:
    true if this ticket is proxiable, false if not.

### isProxy

    public final boolean isProxy()

  Determines is this ticket is a proxy-ticket.

  Returns:
    true if this ticket is a proxy-ticket, false if not.

### isPostdated

    public final boolean isPostdated()

  Determines is this ticket is post-dated.

  Returns:
    true if this ticket is post-dated, false if not.

### isRenewable

    public final boolean isRenewable()

  Determines is this ticket is renewable. If so, the `refresh` method can be called, assuming the validity period for renewing is not already over.

  Returns:
    true if this ticket is renewable, false if not.

### isInitial

    public final boolean isInitial()

  Determines if this ticket was issued using the Kerberos AS-Exchange protocol, and not issued based on some ticket-granting ticket.

  Returns:
    true if this ticket was issued using the Kerberos AS-Exchange protocol, false if not.

### getFlags

    public final boolean[] getFlags()

  Returns the flags associated with this ticket. Each element in the returned array indicates the value for the corresponding bit in the ASN.1 BitString that represents the ticket flags.

  Returns:
    the flags associated with this ticket.

### getAuthTime

    public final java.util.Date getAuthTime()

  Returns the time that the client was authenticated.

  Returns:
    the time that the client was authenticated.

### getStartTime

    public final java.util.Date getStartTime()

  Returns the start time for this ticket's validity period.

  Returns:
    the start time for this ticket's validity period.

### getEndTime

    public final java.util.Date getEndTime()

  Returns the expiration time for this ticket's validity period.

  Returns:
    the expiration time for this ticket's validity period.

### getRenewTill

    public final java.util.Date getRenewTill()

  Returns the latest expiration time for this ticket, including all renewals. This will return a null value for non-renewable tickets.

  Returns:
    the latest expiration time for this ticket.

### getClientAddresses

    public final java.net.InetAddress[] getClientAddresses()

  Returns a list of addresses from where the ticket can be used.

  Returns:
    ths list of addresses or null, if the field was not provided.

### getEncoded

    public final byte[] getEncoded()

  Returns an ASN.1 encoding of the entire ticket.

  Returns:
    an ASN.1 encoding of the entire ticket.

### isCurrent

    public boolean isCurrent()

  Determines if this ticket is still current.

  Specified by:
    `isCurrent` in interface `javax.security.auth.Refreshable`
  Returns:
    DOCUMENT ME!

### refresh

    public void refresh()
                 throws javax.security.auth.RefreshFailedException

  Extends the validity period of this ticket. The ticket will contain a new session key if the refresh operation succeeds. The refresh operation will fail if the ticket is not renewable or the latest allowable renew time has passed. Any other error returned by the KDC will also cause this method to fail. Note: This method is not synchronized with the the accessor methods of this object. Hence callers need to be aware of multiple threads that might access this and try to renew it at the same time.

  Specified by:
    `refresh` in interface `javax.security.auth.Refreshable`
  Throws:
    `javax.security.auth.RefreshFailedException` - if the ticket is not renewable, or the latest allowable renew time has passed, or the KDC returns some error.
  See Also:
    `isRenewable()`, `getRenewTill()`

### destroy

    public void destroy()
                 throws javax.security.auth.DestroyFailedException

  Destroys the ticket and destroys any sensitive information stored in it.

  Specified by:
    `destroy` in interface `javax.security.auth.Destroyable`
  Throws:
    `javax.security.auth.DestroyFailedException`

### isDestroyed

    public boolean isDestroyed()

  Determines if this ticket has been destroyed.

  Specified by:
    `isDestroyed` in interface `javax.security.auth.Destroyable`
  Returns:
    DOCUMENT ME!

### toString

    public java.lang.String toString()

  DOCUMENT ME!

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    DOCUMENT ME!

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD